"use strict";
//=================================================================================
class SPE4 {
	//----------------------------------------------------------------------------
	Data;			// Объект свойств полученный из JSON
	Img;			// Фоновые изображения
	Map;			// Карты для фоновых изображений
	Pic;			// Вплвающие картинки и оверлеи
	PicSrc;			// Src вплвающих картинок и оверлеев
	Pictures;		// Кол-во всплывающих картинок и оверлеев
	AudioPlayer;	// [over,click,dblclick]
	Color;			// Текущий цвет карты под курсором
	Color2;			// Предыдущее значение цвета карты под курсором
	Changed;		// Изменился ли цвет карты под курсором
	Ready;			// Готовы обрабатывать определение значения цвета карты под курсором
	MapData;		// Массив захваченных пикселей с карты
	Properties;		// Текущие свойства (для данного цвета карты)
	PlayEnabled;	// Разрешено ли воспроизведение
	Bubble;			// Переменная класса SPE4_ShowBubble для отображения сообщений
	CanvasWidth;	// Ширина canvas
	CanvasHeight;	// Высота canvas
	BorderWidth;	// Ширина рамкивокруг canvas
	//----------------------------------------------------------------------------
	constructor() {	
		var i,json,obj,width,height,id;
		this.Bubble=new SPE4_ShowBubble();
		this.PlayEnabled=false; // Пока нет подтверждения пользователя
		// Для каждого объекта вызываем соответсвующие функции
		this.AudioPlayer=[];
		this.Data=[];
		this.Img=[];
		this.Pic=[];
		this.PicSrc=[];
		this.CanvasWidth=[];
		this.CanvasHeight=[];
		this.Map=new SPE4_Map();
		this.BorderWidth=10;
		// Задаём значения для плееров
		for (i=0;i<4;i++) this.AudioPlayer[i]="";
		// Цикл по всем объектам
		for (i=0;i<SPE_DATA.length;i++) {
			json=JSON.parse(SPE_DATA[i]);
			this.Data[i]=new Object(json);
			// Проверяем, есть ли объект с таким id
			obj=document.getElementById(json.id);
			if (obj===null) {
			}
			else {
				// Получаем id
				id=json.id;
				// Получаем src, width, height
				width=obj.width;
				height=obj.height;
				this.CanvasWidth[i]=width;
				this.CanvasHeight[i]=height;
				this.Data[i].src=obj.src;
				this.Data[i].width=obj.width;
				this.Data[i].height=obj.height;
				// Заменяем на canvas с определённым id и свойствами
				obj.outerHTML="<canvas class='SPE4' id='"+id+"' width='"+width+"' height='"+height+"'  onmousemove='SPE.onmousemove(event,"+i+")' onmouseover='SPE.onmouseover("+i+")' onmouseout='SPE.onmouseout("+i+")' onclick='SPE.onclick("+i+")' ondblclick='SPE.ondblclick("+i+")'></canvas>";
				// Загрузка фонов
				this.Img[i]=new Image;
				this.Img[i].i=i;
				this.Img[i].onload=function() { SPE.onmouseout(this.i); }
				this.Img[i].src=obj.src;
			}
			// Выводим в canvas картинку
			this.onmouseout(i);
		}
	}
	//----------------------------------------------------------------------------
	onmouseover(i) {
		var ctx,canvas,imgd,j,obj;
		// Выводим в canvas наше изображение-карту
		canvas=document.getElementById(this.Data[i].id);
		ctx=canvas.getContext('2d');
		this.Map.setData(this.Data[i].Map);
		this.Color=-1;
		this.Ready=true;
		// Фоновая музыка
		this.playBackgroundAudio(i);
		// Анализируем все свойства и добавляем в массив изображений все изображения
		this.Pic=[];
		this.PicSrc=[];
		this.Pictures=0;
		if (typeof this.Data[i].colors!=='undefined') {
			for (j=0;j<this.Data[i].colors.length;j++) {
				if (typeof this.Data[i].colors[j].properties!=='undefined') {
					const mode=["over","click","dblclick"];
					mode.forEach((name)=>{
						obj=new Object;
						obj=this.Data[i].colors[j].properties[name];
						// picture,src,x1,y1,x2,y2
						if (typeof obj.picture!=='undefined') {
							if (obj.picture.src!=='') {
								this.Pic[this.Pictures]=new Image();
								this.Pic[this.Pictures].src=obj.picture.src;
								this.PicSrc[this.Pictures]=obj.picture.src;
								this.Pictures++;
							}
						}
						// overlay,src,x1,y1
						if (typeof obj.overlay!=='undefined') {
							if (obj.overlay.src!=='') {
								this.Pic[this.Pictures]=new Image();
								this.Pic[this.Pictures].src=obj.overlay.src;
								this.PicSrc[this.Pictures]=obj.overlay.src;
								this.Pictures++;
							}
						}
					});
				}
			}
		}
	}
	//----------------------------------------------------------------------------
	onmouseout(i) {
		var canvas,ctx,j;
		// Выводим в canvas отмасштабированный фон
		canvas=document.getElementById(this.Data[i].id);
		ctx=canvas.getContext('2d');
		ctx.drawImage(this.Img[i],0,0,this.CanvasWidth[i],this.CanvasHeight[i]);
		// Отключаем звук
		for (j=0;j<4;j++) {
			if (this.AudioPlayer[j]!=="") { 
				this.AudioPlayer[j].pause(); 
				this.AudioPlayer[j].src=""; 
				this.AudioPlayer[j]="";
			}
		}
		this.Color=-1;
		this.Changed=true;
		this.Ready=false;
	}
	//----------------------------------------------------------------------------
	onmousemove(evt,i) {
		var obj,x,y,n,canvas,ctx;
		// Проверка на готовность
		if (!this.Ready) return;
		// Находим координаты курсора
		obj=document.getElementById(this.Data[i].id);
		x=evt.pageX-obj.offsetLeft-this.BorderWidth;
		y=evt.pageY-obj.offsetTop-this.BorderWidth;
		// Вычисляем цвет карты
		this.Color2=this.Color;
		this.Color=this.Map.getColor(x,y);
		if (this.Color!=this.Color2) this.Changed=true; else this.Changed=false;
		if (this.Changed) {
			this.Properties=this.getProperties(i,this.Color);
			this.processActions(i,"over");
		}
	}
	//----------------------------------------------------------------------------
	onclick(i) {
		this.processActions(i,"click");
	}
	//----------------------------------------------------------------------------
	ondblclick(i) {
		this.processActions(i,"dblclick");
	}
	//----------------------------------------------------------------------------
	// Обработка действий
	// e ("over", "click", "dblclick")
	//----------------------------------------------------------------------------
	processActions(i,e) {
		var canvas,ctx,k;
		// Если свойств для данной области нет, то отбой
		if (this.Properties!=="") {
			// Копирование в буфер обмена
			if (this.Properties[e].copytext!="") {
				// Копирование текста в буфер обмена
				// Важное условие: страничка должна быть по адресу https://...
				// More info: https://web.dev/async-clipboard/
				try {
					navigator.clipboard.writeText(this.Properties[e].copytext.replace("|","\n"));
					console.log('Page URL copied to clipboard');
				} catch (err) { console.error('Failed to copy:',err); }
			}
			// Открыть страничку
			if (this.Properties[e].link!="") window.open(this.Properties[e].link);
			// Вызвать JavaScript ф-ию
			if (this.Properties[e].jscode!="") {
			}
			// Перерисовать картинку (и наложить если надо оверлей)
			this.draw(i,e);
			canvas=document.getElementById(this.Data[i].id);
			ctx=canvas.getContext('2d');
			// Вывести текстовое изображение
			if (this.Properties[e].message.text!=="") {
				this.Bubble.bubble(ctx,
					this.Properties[e].message.x1,this.Properties[e].message.y1,
					this.Properties[e].message.x2,this.Properties[e].message.y2,
					this.Properties[e].message.text,Math.round(this.CanvasWidth[i]/3),
					this.Properties[e].message.style,this.Properties[e].message.type);
			}
			// Вывести картинку
			if (this.Properties[e].picture.src!=="") {
				k=this.getPictureIndexBySrc(this.Properties[e].picture.src);
				if (k>=0) {
					this.Bubble.picture(ctx,
						this.Properties[e].picture.x1,this.Properties[e].picture.y1,
						this.Properties[e].picture.x2,this.Properties[e].picture.y2,
						this.Properties[e].picture.style,this.Properties[e].picture.type,
						this.Pic[k]);
				}
			}			
			// Воспроизведение звука
			this.playAudio(i,this.getIndexByProp(e));
		}
		else {
			// Выводим наше изображение
			this.draw(i,e);
		}
		// Если фоновое воспроизведение ещё не разрешено
		if (!this.PlayEnabled) this.playBackgroundAudio(i);
	}
	//----------------------------------------------------------------------------
	// Получить свойство по индексу
	//----------------------------------------------------------------------------
	getPropByIndex(k) {
		var res="";
		switch(k) {
			case 1: res="over"; break;
			case 2: res="click"; break;
			case 3: res="dblclick"; break;
		}
		return(res);
	}
	//----------------------------------------------------------------------------
	// Получить свойство по индексу
	//----------------------------------------------------------------------------
	getIndexByProp(e) {
		var res=0;
		switch(e) {
			case "over"		: res=1; break;
			case "click"	: res=2; break;
			case "dblclick"	: res=3; break;
		}
		return(res);
	}
	//----------------------------------------------------------------------------
	// Получить свойство по индексу
	//----------------------------------------------------------------------------
	getPictureIndexBySrc(src) {
		var j;
		for (j=0;j<this.Pictures;j++) {
			if (this.PicSrc[j]==src) {
				return(j);
			}
		}
		return(-1); // Не нашли
	}
	//----------------------------------------------------------------------------
	// Проиграть фоновую музыку
	//----------------------------------------------------------------------------
	playBackgroundAudio(i) {
		var volume=1,promise;
		// Прооверки
		if (this.AudioPlayer[0]!=="") { this.AudioPlayer[0].pause(); this.AudioPlayer[0].src=""; } // Уже проигрывается!
		if (typeof this.Data[i].audio==='undefined') { this.AudioPlayer[0]=""; return; }
		if (typeof this.Data[i].audio.src==='undefined') { this.AudioPlayer[0]=""; return; }
		if (this.Data[i].audio.src=='') { this.AudioPlayer[0]=""; return; }
		// Воспроизведение
		this.AudioPlayer[0]=new Audio(this.Data[i].audio.src);
		promise=this.AudioPlayer[0].play();
		if (promise!==undefined) {
			promise.then(_ => { // Autoplay started!
				if (typeof this.Data[i].audio.volume!=='undefined') this.AudioPlayer[0].volume=this.Data[i].audio.volume;
				this.PlayEnabled=true;
			}).catch(error => { // Autoplay was prevented.
			});
		}
	}
	//----------------------------------------------------------------------------
	// Проиграть звук
	// i - Номер объекта на странице
	// k - номер плеера (0 - фон, 1 - over, 2 - click, 3 - dblclick)
	//----------------------------------------------------------------------------
	playAudio(i,k) {
		var volume=1,promise,e;
		// Если событие click или dblclick
		if (k>=2) {
			if (!this.PlayEnabled) this.playBackgroundAudio(i);
		}
		// Проиграть фоновую музыку
		if (k==0) { this.playBackgroundAudio(i); return; }
		// Если нет свойств для данного цвета фона
		if (this.Properties==="") return;
		e=this.getPropByIndex(k); // Получаем "over",...
		if (this.Properties[e].audio.src!="") {
			// Если идёт воспроизведение, то сперва тормозим его
			if (this.AudioPlayer[k]!=="") { 
				this.AudioPlayer[k].pause(); 
				this.AudioPlayer[k].src=""; 
			}
			// Пытаемся проиграть
			this.AudioPlayer[k]=new Audio(this.Properties[e].audio.src);
			promise=this.AudioPlayer[k].play();
			if (promise!==undefined) {
				promise.then(_ => { // Autoplay started!
					this.AudioPlayer[k].volume=this.Properties[e].audio.volume;
					if (!this.PlayEnabled) {
						this.playBackgroundAudio(i);
						this.PlayEnabled=true;
					}
				}).catch(error => { // Autoplay was prevented.
				});
			}
			else this.AudioPlayer[k]="";
		}
	}
	//----------------------------------------------------------------------------
	// Получить свойства i-го объекта n-го цвета
	//----------------------------------------------------------------------------
	getProperties(i,n) {
		var result,obj,j;
		result=[];
		if (typeof this.Data[i].colors!=='undefined') {
			for (j=0;j<this.Data[i].colors.length;j++) {
				if (this.Data[i].colors[j].color==n) {
					if (typeof this.Data[i].colors[j].properties!=='undefined') {
						const mode=["over","click","dblclick"];
						mode.forEach((name)=>{
							obj=new Object;
							obj=this.Data[i].colors[j].properties[name];
							result[name]=new Object;
							// picture,src,style,type,x1,y1,x2,y2
							result[name].picture=new Object;
							if (typeof obj.picture!=='undefined') {
								result[name].picture.src=obj.picture.src;
								result[name].picture.style=obj.picture.style;
								result[name].picture.type=obj.picture.type;
								result[name].picture.x1=obj.picture.x1;
								result[name].picture.y1=obj.picture.y1;
								result[name].picture.x2=obj.picture.x2;
								result[name].picture.y2=obj.picture.y2;
							}
							else result[name].picture.src="";
							// overlay,src,x1,y1
							result[name].overlay=new Object;
							if (typeof obj.overlay!=='undefined') {
								result[name].overlay.src=obj.overlay.src;
								result[name].overlay.x=obj.overlay.x;
								result[name].overlay.y=obj.overlay.y;
							}
							else result[name].overlay.src="";
							// message,style,type,text,x1,y1,x2,y2
							result[name].message=new Object;
							if (typeof obj.message!=='undefined') {
								result[name].message.text=obj.message.text;
								result[name].message.style=obj.message.style;
								result[name].message.type=obj.message.type;
								result[name].message.x1=obj.message.x1;
								result[name].message.y1=obj.message.y1;
								result[name].message.x2=obj.message.x2;
								result[name].message.y2=obj.message.y2;
							}
							else result[name].message.text="";
							// copytext
							if (typeof obj.copytext!=='undefined') result[name].copytext=obj.copytext;
							else result[name].copytext="";
							// jscode
							if (typeof obj.jscode!=='undefined') result[name].jscode=obj.jscode;
							else result[name].jscode="";
							// audio,[volume]
							result[name].audio=new Object;
							if (typeof obj.audio!=='undefined') {
								result[name].audio.src=obj.audio.src;
								if (typeof obj.audio.volume!=='undefined') result[name].audio.volume=obj.audio.volume;
								else result[name].audio.volume=1;
							}
							else result[name].audio.src="";
							// link
							if (typeof obj.link!=='undefined') result[name].link=obj.link;
							else result[name].link="";
							// background: brightness,contrast,gamma,grayscale
							result[name].background=new Object;
							if (typeof obj.background!=='undefined') {
								result[name].background.brightness=obj.background.brightness;
								result[name].background.contrast=obj.background.contrast;
								result[name].background.gamma=obj.background.gamma;
								result[name].background.grayscale=obj.background.grayscale;
							}
							else {
								result[name].background.brightness=0;
								result[name].background.contrast=0;
								result[name].background.gamma=1.;
								result[name].background.grayscale=false;
							}
							// area: brightness,contrast,gamma,grayscale
							result[name].area=new Object;
							if (typeof obj.area!=='undefined') {
								result[name].area.brightness=obj.area.brightness;
								result[name].area.contrast=obj.area.contrast;
								result[name].area.gamma=obj.area.gamma;
								result[name].area.grayscale=obj.area.grayscale;
							}
							else {
								result[name].area.brightness=0;
								result[name].area.contrast=0;
								result[name].area.gamma=1.;
								result[name].area.grayscale=false;
							}
						});
						return(result);
					}
				}
			}
		}
		return("");
	}
	//----------------------------------------------------------------------------
	// Рисует в canvas фон, накладывает оверлей и применяет эффекты
	//----------------------------------------------------------------------------
	draw(i,ee) {
		var canvas,ctx,j,k,imgd,mat1,mat2,n,x,y,xx,yy,pos,pos2,width2,height2,r,g,b;
		// Выводим в canvas отмасштабированный фон
		canvas=document.getElementById(this.Data[i].id);
		ctx=canvas.getContext('2d');
		ctx.drawImage(this.Img[i],0,0,this.CanvasWidth[i],this.CanvasHeight[i]);
		if (this.Properties==="") { return; }
		// Если есть overlay, то выводим на canvas отмасштабированный overlay
		if (this.Properties[ee].overlay.src!=="") {
			k=this.getPictureIndexBySrc(this.Properties[ee].overlay.src);
			if (k>=0) {
				var scale_x,scale_y;
				// Находим масштаб по x и по y
				scale_x=this.CanvasWidth[i]/this.Img[i].width;
				scale_y=this.CanvasHeight[i]/this.Img[i].height;
				// Выводим изображение с нужными пропорциями
				ctx.drawImage(this.Pic[k],
					scale_x*this.Properties[ee].overlay.x,scale_y*this.Properties[ee].overlay.y,
					scale_x*this.Pic[k].width,scale_y*this.Pic[k].height);
			}
		}

		// Если есть недефолтные параметры эффектов, то
		if ((this.Properties[ee].background.brightness!=0)||(this.Properties[ee].background.contrast!=0)
			||(this.Properties[ee].background.gamma!=1.0)||(this.Properties[ee].background.grayscale)
			||(this.Properties[ee].area.brightness!=0)||(this.Properties[ee].area.contrast!=0)
			||(this.Properties[ee].area.gamma!=1.0)||(this.Properties[ee].area.grayscale)) {
				try {
					// Сохраняем содержимое canvas в буфер
					imgd=ctx.getImageData(0,0,this.CanvasWidth[i],this.CanvasHeight[i]);
					// Вычисляем матрицу преобразований для фона и области
					mat1=[];
					mat2=[];
					for (j=0;j<256;j++) { 
						mat1[j]=j; 
						mat2[j]=j; 
						// Яркость
						mat1[j]=1*mat1[j]+1*this.Properties[ee].background.brightness;
						mat2[j]=1*mat2[j]+1*this.Properties[ee].area.brightness;
						// Контраст
						mat1[j]=this.getContrast(mat1[j],this.Properties[ee].background.contrast);
						mat2[j]=this.getContrast(mat2[j],this.Properties[ee].area.contrast);
						// Гамма
						mat1[j]=255*Math.pow(mat1[j]/255,1.0/this.Properties[ee].background.gamma);
						mat2[j]=255*Math.pow(mat2[j]/255,1.0/this.Properties[ee].area.gamma);
						// Проверки
						mat1[j]=Math.round(mat1[j]);
						if (mat1[j]<0) mat1[j]=0;
						if (mat1[j]>255) mat1[j]=255;
						mat2[j]=Math.round(mat2[j]);
						if (mat2[j]<0) mat2[j]=0;
						if (mat2[j]>255) mat2[j]=255;
					}
					for (y=0;y<this.CanvasHeight[i];y++) {
						for (x=0;x<this.CanvasWidth[i];x++) {
							// Находим цвет пикселя
							pos=4*(x+y*this.CanvasWidth[i]);
							r=imgd.data[pos];
							g=imgd.data[pos+1];
							b=imgd.data[pos+2];
							// Определяем это текущая область  или нет
							if (this.Map.getColor(x,y)==this.Color) { // Текущая область
								// Если надо, то делаем его серым
								if (this.Properties[ee].area.grayscale) r=g=b=~~((r+g+b)/3);
								r=mat2[r];
								g=mat2[g];
								b=mat2[b];
							}
							else { // Остальные области
								// Если надо, то делаем его серым
								if (this.Properties[ee].background.grayscale) r=g=b=~~((r+g+b)/3);
								r=mat1[r];
								g=mat1[g];
								b=mat1[b];
							}
							// Сохраняем
							imgd.data[pos]=r;
							imgd.data[pos+1]=g;
							imgd.data[pos+2]=b;
						}
					}
					// Восстанавливаем содержимое canvas из буфера
					ctx.putImageData(imgd,0,0);
				}
				catch(e) {
					console.log("Error getImageData: вероятно запуск с локального диска");
				}
		}
	}
	
	//----------------------------------------------------------------------------
	// Значение в зависимости от параметра контрастности
	//----------------------------------------------------------------------------
	getContrast(val,Contrast) {
		if (Contrast==0) return(val);
		if (Contrast>0) { // Увеличить контраст
			if (val>127) val=127+(val-127)*(255+9*Contrast)/255;
			else val=127-(127-val)*(255+9*Contrast)/255;
		}
		else { // Уменьшить контраст
			if (val>127) val=127+(val-127)*255/(255-9*Contrast);
			else val=127-(127-val)*255/(255-9*Contrast);
		}
		return(val);
	}
	
}
//=================================================================================
class SPE4_Map {
	
	Lines;	// Массив строк 

	constructor() {	
	}
	
	// Разбивка на строки
	setData(s) {
		this.Lines=s.split(" ");
	}
	
	// Получение цвета пикселя
	getColor(xx,yy) {
		var x,y,s,i,l,color,pos;
		// Находим x и y
		x=~~(xx/2);
		y=~~(yy/2);
		// Проверяем границы y
		if ((y<0)||(y>=this.Lines.length)) return(0);
		// Проверяем границы x
		if (x<0) return(0);
		s=this.Lines[y];
		if (s=="") return(0); 
		l=s.length;
		pos=0;
		for (i=0;i<l;i+=4) {
			color=parseInt(s.substring(i,i+2),16);
			pos+=parseInt(s.substring(i+2,i+4),16);
			if (x<=pos) return(color);
		}
		return(0);
	}
	
}
//=================================================================================
class SPE4_ShowBubbleStyle {
	
	constructor() {
		this.style=[];
	}

	// Добавить стиль
	add(style_name,padding,text_align,fill_color,text_color,border_color,border_width,font,line_height) {
		var n=this.style.length;
		//console.log("n="+n);
		this.style[n]=new Object();
		this.style[n].style_name=style_name;
		this.style[n].padding=padding;
		this.style[n].text_align=text_align;
		this.style[n].fill_color=fill_color;
		this.style[n].text_color=text_color;
		this.style[n].border_color=border_color;
		this.style[n].border_width=border_width;
		this.style[n].font=font;
		this.style[n].line_height=line_height;
	}
	
	// Выбрать стиль
	selectStyle(name) {
		var i,n;
		n=this.style.length;
		for (i=0;i<n;i++) {
			if (this.style[i].style_name==name) {
				this.style_name=this.style[i].style_name;
				this.padding=this.style[i].padding;
				this.text_align=this.style[i].text_align;
				this.fill_color=this.style[i].fill_color;
				this.text_color=this.style[i].text_color;
				this.border_color=this.style[i].border_color;
				this.border_width=this.style[i].border_width;
				this.font=this.style[i].font;
				this.line_height=this.style[i].line_height;
			}
		}
	}
	
}
//=================================================================================
class SPE4_ShowBubble {
	
	constructor() {
		// Заранее определяем несколько стилей
		this.style=new SPE4_ShowBubbleStyle();
		// Small
		this.addStyle("blue_small",9,"center","blue","white","rgb(0,0,50)",1,"8px cursive",9);
		this.addStyle("yellow_small",11,"center","yellow","red","red",1,"10px Comic Sans MS",11);
		this.addStyle("gray_small",10,"center","gray","black","black",1,"9px sans-serif",10);
		this.addStyle("black_small",9,"left","black","white","white",1,"8px monospace",9);
		this.addStyle("green_small",9,"center","green","white","rgb(0,70,0)",1,"8px fantasy",9);
		this.addStyle("red_small",12,"center","red","black","black",1,"bold 10px Arial",12);
		// Middle
		this.addStyle("blue_middle",15,"center","blue","white","rgb(0,0,50)",2,"12px cursive",12);
		this.addStyle("yellow_middle",20,"center","yellow","red","red",3,"14px Comic Sans MS",15);
		this.addStyle("gray_middle",20,"center","gray","black","black",3,"15px sans-serif",16);
		this.addStyle("black_middle",12,"left","black","white","white",2,"15px monospace",16);
		this.addStyle("green_middle",20,"center","green","white","rgb(0,70,0)",2,"16px fantasy",17);
		this.addStyle("red_middle",10,"center","red","black","black",3,"bold 14px Arial",15);
		// Big
		this.addStyle("blue_big",30,"center","blue","white","rgb(0,0,50)",2,"18px cursive",22);
		this.addStyle("yellow_big",25,"center","yellow","red","red",4,"20px Comic Sans MS",25);
		this.addStyle("gray_big",25,"center","gray","black","black",3,"18px bold sans-serif",22);
		this.addStyle("black_big",22,"left","black","white","white",4,"18px monospace",22);
		this.addStyle("green_big",25,"center","green","white","rgb(0,70,0)",2,"22px fantasy",25);
		this.addStyle("red_big",28,"center","red","black","black",2,"bold 20px Arial",23);
	}
	
	//----------------------------------------------------------------------------
	// Разделение текста на строки
	//----------------------------------------------------------------------------
	// На входе - текстовая строка, ширина бабла
	// На выходе - кол-во строк, массив строк, высота, и ratio
	splitText(ctx,str,width) {
		var begin_str="",current="",result="",s,c,i,n,metrix;
		n=str.length;
		// Цикл по всем символам
		for (i=0;i<n;i++) {
			c=str.substring(i,i+1);
			// Если текущий символ пробел, то пытаемся определить умещается ли текущая строка в заданную ширину
			if ((c==" ")||(c=="|")) {
				s=begin_str+current; // Объединяем строку до этого и текущее слово
				s=s.trim();
				metrix=ctx.measureText(s);
				if (metrix.width>width) { // Слишком длинная строка, берём начало, а слово оставляем на потом
					if (c=="|") { // Если в самой строке есть перевод строки
						result=result+begin_str.trim()+"|"+current.trim()+"|";
						begin_str="";
						current="";
					}
					else { // В самой строке нет перевода строки
						result=result+" "+begin_str.trim()+"|";
						begin_str=current.trim()+" ";
						current="";
					}
				}
				else { // Строка не заполнена до края
					if (c=="|") { // Если в самой строке есть перевод строки
						result=result+" "+s.trim()+"|";
						begin_str="";
						current="";
					}
					else { // В самой строке нет перевода строки 
						begin_str=begin_str.trim()+" "+current.trim()+" ";
						current="";
					}
				}
			}
			else current=current+c;
		}
		result=result+begin_str.trim()+" "+current.trim();
		n=result.length;
		if (result.substring(n-1,n)=="|") result=result.substring(0,n-2);
		return(result);
	}
	
	//----------------------------------------------------------------------------
	// Установить свойства
	//----------------------------------------------------------------------------
	addStyle(style_name,padding,text_align,fill_color,text_color,border_color,border_width,font,line_height) {
		this.style.add(style_name,padding,text_align,fill_color,text_color,border_color,border_width,font,line_height);
	}
	
	//----------------------------------------------------------------------------
	// Выбрать стиль
	//----------------------------------------------------------------------------
	selectStyle(name) {
		this.style.selectStyle(name);
	}
	
	//----------------------------------------------------------------------------
	// Вывести изображение
	//----------------------------------------------------------------------------
	// ctx - контекст рисования
	// xc,yc - координаты центра области
	// xt,yt - координаты конца хвостика (если есть, зависит от типа)
	// style - стиль
	// bubble_type - тип области {'pointer','circle'}
	// img - изображение
	picture(ctx,xc,yc,xt,yt,style,bubble_type,img) {
		var i,metrix,lines,x,y,res,sx,sy,dx,dy;
		dx=img.width;
		dy=img.height;
		this.style.selectStyle(style);
		// Прменяем свойства стиля
		ctx.fillStyle=this.style.fill_color;
		ctx.strokeStyle=this.style.border_color;
		ctx.lineWidth=this.style.border_width;
		// Свойства тени
		ctx.shadowColor='rgba(0,0,0,0.4)';
		ctx.shadowOffsetX=25;
		ctx.shadowOffsetY=25;
		ctx.shadowBlur=8;
		// Выводим изображение
		if (bubble_type=="pointer") {
			// Рисуем объект с тенью
			this.draw(ctx,xc,yc,xt,yt,dx+this.style.padding,dy+this.style.padding,bubble_type);
			// Рисуем объект без тени
			ctx.shadowColor='rgba(0,0,0,0)';
			this.draw(ctx,xc,yc,xt,yt,dx+this.style.padding,dy+this.style.padding,bubble_type);
			ctx.drawImage(img,xc-dx/2,yc-dy/2);
		}
		else if (bubble_type=="circle") {
			res=this.getPictureSizes(dx,dy);
			// Рисуем объект с тенью
			this.draw(ctx,xc,yc,xt,yt,res.dx+this.style.padding,res.dy+this.style.padding,bubble_type);
			// Рисуем объект без тени
			ctx.shadowColor='rgba(0,0,0,0)';
			this.draw(ctx,xc,yc,xt,yt,res.dx+this.style.padding,res.dy+this.style.padding,bubble_type);
			ctx.save();	
			ctx.beginPath();
			ctx.arc(xc,yc,res.dx/2,0,Math.PI*2,true);
			ctx.clip();
			ctx.drawImage(img,res.x,res.y,res.dx,res.dy,xc-res.dx/2,yc-res.dy/2,res.dx,res.dy);
			ctx.restore();
		}
	}
	
	//----------------------------------------------------------------------------
	// Получить координаты квадрата из прямоугольного изображения
	//----------------------------------------------------------------------------
	getPictureSizes(source_width,source_height) {
		var x,y,dx,dy,source_ratio,destination_ratio;
		source_ratio=source_width/source_height;
		if (source_ratio>=1.0) { // Исходное изображение более вытянутое по горизонтали
			dy=source_height;
			dx=dy;
			y=0;
			x=Math.round((source_width-dx)/2);
		}
		else {
			dx=source_width;
			dy=dx;
			x=0;
			y=Math.round((source_height-dy)/2);
		}
		return{x:x,y:y,dx:dx,dy:dy};
	}
	
	//----------------------------------------------------------------------------
	// Вывести текст
	//----------------------------------------------------------------------------
	// ctx - контекст рисования
	// xc,yc - координаты центра области
	// xt,yt - координаты конца хвостика (если есть, зависит от типа)
	// text_str - текстовая строка (в ней символ '|' - это разделитель строк)
	// max_width - максимальная ширина строки
	// style - стиль
	// bubble_type - тип области {'speech','think','rectangle','pointer','circle'}
	bubble(ctx,xc,yc,xt,yt,text_str,max_width,style,bubble_type) {
		var i,dx,dy,metrix,lines,x,y;
		this.style.selectStyle(style);
		// Прменяем свойства стиля
		ctx.fillStyle=this.style.fill_color;
		ctx.strokeStyle=this.style.border_color;
		ctx.font=this.style.font;
		ctx.textAlign=this.style.text_align;
		ctx.lineWidth=this.style.border_width;
		// Находим кол-во строк
		if (max_width>0) text_str=this.splitText(ctx,text_str,max_width);
		lines=text_str.split("|");
		for (i=0;i<lines.length;i++) {
			lines[i]=lines[i].trim();
		}
		// Находим максимальную длину строки
		dx=0;
		for (i=0;i<lines.length;i++) {
			metrix=ctx.measureText(lines[i]);
			if (metrix.width>dx) dx=metrix.width;
		}
		// Размеры объекта
		dx=dx+2*this.style.padding;
		dy=lines.length*this.style.line_height+2*this.style.padding;
		// Рисуем объект с тенью
		ctx.shadowColor='rgba(10,10,10,0.4)';
		ctx.shadowOffsetX=25;
		ctx.shadowOffsetY=25;
		ctx.shadowBlur=8;
		this.draw(ctx,xc,yc,xt,yt,dx,dy,bubble_type);
		// Рисуем объект без тени
		ctx.shadowColor='rgba(100,100,100,0)';
		this.draw(ctx,xc,yc,xt,yt,dx,dy,bubble_type);
		// Выводим строки
		ctx.shadowColor='rgba(0,0,0,0)';
		ctx.textBaseline="middle";
		ctx.textAlign=this.style.text_align;
		ctx.fillStyle=this.style.text_color;
		for (i=0;i<lines.length;i++) {
			metrix=ctx.measureText(lines[i]);
			switch (this.style.text_align) {
				case  "center": x=xc; break;
				case  "left"  : x=Math.round(xc-dx/2+this.style.padding); break;
				case  "right" : x=Math.round(xc+dx/2-this.style.padding); break;
			}
			y=yc+this.style.line_height*(0.5+i-lines.length/2)
			ctx.fillText(lines[i],x,y);
		}
	}
	
	//----------------------------------------------------------------------------
	// Нарисовать каркас (без текста)
	//----------------------------------------------------------------------------
	// ctx - контекст рисования
	// xc,yc - координаты центра области
	// xt,yt - координаты конца хвостика (если есть, зависит от типа)
	// dx,dy - размеры области
	// bubble_type - тип области {'speech','think','rectangle','pointer','circle'}
	draw(ctx,xc,yc,xt,yt,dx,dy,bubble_type) {
		var k=0.6,tail_pos,cp1x,cp1y,cp2x,cp2y,x1,y1,x2,y2,sx,sy,n,i,alpha,betta,r,tail_max=20;
		// Окружность с хвостиком
		if (bubble_type=="circle") { 
			dx=dx/2;
			// Находим угол
			sx=xt-xc;
			sy=yt-yc;
			alpha=Math.asin(-sy/Math.sqrt(sx*sx+sy*sy));
			if (xt<xc) alpha=Math.PI-alpha;
			alpha=alpha-Math.PI*10/180;
			betta=alpha+Math.PI*20/180;
			// Находим диапазон углов
			ctx.beginPath();
			// Рисуем хвостик
			x1=xc+dx*Math.cos(alpha);
			y1=yc-dx*Math.sin(alpha);
			x2=xc+dx*Math.cos(betta);
			y2=yc-dx*Math.sin(betta);
			ctx.moveTo(x1,y1);
			ctx.lineTo(xt,yt);
			ctx.lineTo(x2,y2);
			// Рисуем окружность
			ctx.arc(xc,yc,dx,-betta,-alpha,true);
			ctx.fill();
			//ctx.stroke();
			if (this.style.border_width>0) ctx.stroke();
			return;
		}
		// Прямоугольник без хвостика
		if (bubble_type=="rectangle") {
			ctx.beginPath();
			ctx.moveTo(xc-dx/2,yc-dy/2);
			ctx.lineTo(xc+dx/2,yc-dy/2);
			ctx.lineTo(xc+dx/2,yc+dy/2);
			ctx.lineTo(xc-dx/2,yc+dy/2);
			ctx.lineTo(xc-dx/2,yc-dy/2);
			ctx.fill();
			if (this.style.border_width>0) ctx.stroke();
			return;
		}
		// Прямоугольник с хвостиком
		if (bubble_type=="pointer") {
			ctx.beginPath();
			ctx.moveTo(xc-dx/2,yc-dy/2);
			// Угол точки хвоста
			if (yt==yc) {
				if (xt>=xc) alpha=Math.PI/2;
				else alpha=-Math.PI/2;
			}
			else {
				alpha=-Math.atan((xt-xc)/(yt-yc));
				if (yt<=yc);
				else {
					if (xt>=xc)	alpha=1*alpha+Math.PI;
					else alpha=1*alpha-Math.PI;
				}
			}
			// Угол угловой точки
			betta=Math.atan(dx/dy);
			// Верх
			if (Math.abs(alpha)<=betta) {
				// Находим наше положение
				i=Math.round(tail_max*(alpha+betta)/(2*betta))-1;
				// Уточняем границы
				if (i<1) i=1;
				if (i>tail_max-3) i=tail_max-3;
				// Строим линии
				ctx.lineTo(xc-dx/2+dx*i/tail_max,yc-dy/2);
				ctx.lineTo(xt,yt);
				ctx.lineTo(xc-dx/2+dx*(i+2)/tail_max,yc-dy/2);
				ctx.lineTo(xc+dx/2,yc-dy/2);
			}
			else ctx.lineTo(xc+dx/2,yc-dy/2);
			// Право
			if ((alpha>betta)&&(alpha<Math.PI-betta)) {
				// Находим наше положение
				i=Math.round(tail_max*(alpha-betta)/(Math.PI-2*betta))-1;
				// Уточняем границы
				if (i<1) i=1;
				if (i>tail_max-3) i=tail_max-3;
				// Строим линии
				ctx.lineTo(xc+dx/2,yc-dy/2+dy*i/tail_max);
				ctx.lineTo(xt,yt);
				ctx.lineTo(xc+dx/2,yc-dy/2+dy*(i+2)/tail_max);
				ctx.lineTo(xc+dx/2,yc+dy/2);
			}
			else ctx.lineTo(xc+dx/2,yc+dy/2);
			// Низ
			if ((Math.abs(alpha)>=Math.PI-betta)) {
				// Находим наше положение
				if (alpha<1) alpha=2*Math.PI+alpha;
				i=Math.round(tail_max*(alpha-Math.PI+betta)/(2*betta))-1;
				// Уточняем границы
				if (i<1) i=0;
				if (i>tail_max-3) i=tail_max-3;
				// Строим линии
				ctx.lineTo(xc+dx/2-dx*i/tail_max,yc+dy/2);
				ctx.lineTo(xt,yt);
				ctx.lineTo(xc+dx/2-dx*(i+2)/tail_max,yc+dy/2);
				ctx.lineTo(xc-dx/2,yc+dy/2);
			}
			else ctx.lineTo(xc-dx/2,yc+dy/2);			
			// Лево
			if ((-alpha>betta)&&(-alpha<Math.PI-betta)) {
				// Находим наше положение
				i=Math.round(tail_max*(alpha+Math.PI-betta)/(Math.PI-2*betta))-1;
				// Уточняем границы
				if (i<1) i=1;
				if (i>tail_max-3) i=tail_max-3;
				// Строим линии
				ctx.lineTo(xc-dx/2,yc+dy/2-dy*i/tail_max);
				ctx.lineTo(xt,yt);
				ctx.lineTo(xc-dx/2,yc+dy/2-dy*(i+2)/tail_max);
				ctx.lineTo(xc-dx/2,yc-dy/2);
			}
			else ctx.lineTo(xc-dx/2,yc-dy/2);
			//
			ctx.fill();
			if (this.style.border_width>0) ctx.stroke();
			return;
		}
		// Мысли (несколько эллипсов)
		if (dx/dy>3) dy=~~(dx/3);
		if (bubble_type=="think") {
			n=3;
			for (i=0;i<n;i++) {
				ctx.beginPath();
				x1=xt+(xc-xt)*i/(n+1);
				y1=yt+(yc-yt)*i/(n+1);
				x2=dx*(i+1)/(2*n+1)/2;
				y2=dy*(i+1)/(2*n+1)/2;
				ctx.ellipse(x1,y1,x2,y2,0,0,2*Math.PI);
				ctx.fill();
				if (this.style.border_width>0) ctx.stroke();
			}
		}
		// Рисуем овал
		ctx.beginPath();
		ctx.moveTo(xc-dx/2,yc);
		// Первая четверть
		cp1x=xc-dx/2;
		cp1y=yc-(dy/2)*k;
		cp2x=xc-(dx/2)*k;
		cp2y=yc-dy/2;
		x1=xc-dx/2;
		y1=yc;
		x2=xc;
		y2=yc-dy/2;
		if ((xt<=xc)&&(yt<=yc)&&(bubble_type=='speech')) {
			if (yc==yt) tail_pos=0;
			else if (xc==xt) tail_pos=1;
			else {
				sx=Math.abs(xc-xt);
				sy=Math.abs(yc-yt);
				if (sy<sx) tail_pos=0.5*sy/sx;
				else tail_pos=1-0.5*sx/sy;
			}
			this.bezierCurveToWithTail(ctx,x1,y1,x2,y2,cp1x,cp1y,cp2x,cp2y,tail_pos,xt,yt);
		}
		else this.bezierCurveTo(ctx,x1,y1,x2,y2,cp1x,cp1y,cp2x,cp2y);
		// Вторая четверть
		cp1x=xc+(dx/2)*k;
		cp1y=yc-(dy/2);
		cp2x=xc+dx/2;
		cp2y=yc-(dy/2)*k;
		x1=x2;
		y1=y2;
		x2=xc+dx/2;
		y2=yc;
		if ((xt>xc)&&(yt<=yc)&&(bubble_type=='speech')) {
			if (yc==yt) tail_pos=1;
			else if (xc==xt) tail_pos=0;
			else {
				sx=Math.abs(xc-xt);
				sy=Math.abs(yc-yt);
				if (sy>sx) tail_pos=0.5*sx/sy;
				else tail_pos=1-0.5*sy/sx;
			}
			this.bezierCurveToWithTail(ctx,x1,y1,x2,y2,cp1x,cp1y,cp2x,cp2y,tail_pos,xt,yt);
		}
		else this.bezierCurveTo(ctx,x1,y1,x2,y2,cp1x,cp1y,cp2x,cp2y);
		// Третья четверть
		cp1x=xc+dx/2;
		cp1y=yc+(dy/2)*k;
		cp2x=xc+(dx/2)*k;
		cp2y=yc+dy/2;
		x1=x2;
		y1=y2;
		x2=xc;
		y2=yc+dy/2;
		if ((xt>xc)&&(yt>yc)&&(bubble_type=='speech')) {
			if (yc==yt) tail_pos=0;
			else if (xc==xt) tail_pos=1;
			else {
				sx=Math.abs(xc-xt);
				sy=Math.abs(yc-yt);
				if (sy<sx) tail_pos=0.5*sy/sx; 
				else tail_pos=1-0.5*sx/sy;
			}
			this.bezierCurveToWithTail(ctx,x1,y1,x2,y2,cp1x,cp1y,cp2x,cp2y,tail_pos,xt,yt);
		}
		else this.bezierCurveTo(ctx,x1,y1,x2,y2,cp1x,cp1y,cp2x,cp2y);
		// Четвёртая четверть
		cp1x=xc-(dx/2)*k;
		cp1y=yc+(dy/2);
		cp2x=xc-dx/2;
		cp2y=yc+(dy/2)*k;
		x1=x2;
		y1=y2;
		x2=xc-dx/2;
		y2=yc;
		if ((xt<=xc)&&(yt>yc)&&(bubble_type=='speech')) {
			if (yc==yt) tail_pos=1;
			else if (xc==xt) tail_pos=0;
			else {
				sx=Math.abs(xc-xt);
				sy=Math.abs(yc-yt);
				if (sy<sx) tail_pos=1-0.5*sy/sx;
				else tail_pos=0.5*sx/sy;
			}
			this.bezierCurveToWithTail(ctx,x1,y1,x2,y2,cp1x,cp1y,cp2x,cp2y,tail_pos,xt,yt);
		}
		else this.bezierCurveTo(ctx,x1,y1,x2,y2,cp1x,cp1y,cp2x,cp2y);
		//
		ctx.lineTo(xc-dx/2,yc);
		ctx.fill();
		if (this.style.border_width>0) ctx.stroke();
	}
	
	//----------------------------------------------------------------------------
	// Нарисовать кривую Безье
	//----------------------------------------------------------------------------
	// ctx - контекст рисования
	// x1,y1, x2,y2 - координаты начальной и конечной точек
	// cp1x,cp1y,cp2x,cp2y - координаты контрольных точек
	bezierCurveTo(ctx,x1,y1,x2,y2,cp1x,cp1y,cp2x,cp2y) {
		var i,n=10,x,y,t;
		for (i=0;i<n;i++) {
			t=(i+1)/n;
			x=(1-t)*(1-t)*(1-t)*x1+3*(1-t)*(1-t)*t*cp1x+3*(1-t)*t*t*cp2x+t*t*t*x2;
			y=(1-t)*(1-t)*(1-t)*y1+3*(1-t)*(1-t)*t*cp1y+3*(1-t)*t*t*cp2y+t*t*t*y2;
			ctx.lineTo(x,y);
		}
	}

	//----------------------------------------------------------------------------
	// Нарисовать кривую Безье и хвостик
	//----------------------------------------------------------------------------
	// ctx - контекст рисования
	// x1,y1, x2,y2 - координаты начальной и конечной точек
	// cp1x,cp1y,cp2x,cp2y - координаты контрольных точек
	// tail_pos - из какого положения рисовать хвостик (или не рисовать при -1)
	// x_tail,y_tail - координаты конца хвостика
	bezierCurveToWithTail(ctx,x1,y1,x2,y2,cp1x,cp1y,cp2x,cp2y,tail_pos,x_tail,y_tail) {
		var i,j,n=20,x,y,h=0.05,t,X,Y,P,d1,d2,a,b;
		// Вычисления
		X=[];
		Y=[];
		P=[];
		for (i=0;i<n;i++) { // Рисуем кривую по частям
			t=(i+1)/n;
			x=(1-t)*(1-t)*(1-t)*x1+3*(1-t)*(1-t)*t*cp1x+3*(1-t)*t*t*cp2x+t*t*t*x2;
			y=(1-t)*(1-t)*(1-t)*y1+3*(1-t)*(1-t)*t*cp1y+3*(1-t)*t*t*cp2y+t*t*t*y2;
			// Находим расстояние до точки 1
			a=Math.abs(x-x1);
			b=Math.abs(y-y1);
			d1=Math.sqrt((a*a+b*b));
			// Находим расстояние до точки 2
			a=Math.abs(x-x2);
			b=Math.abs(y-y2);
			d2=Math.sqrt((a*a+b*b));
			// Находим позицию, как соотношение между точками
			X[i]=x;
			Y[i]=y;
			P[i]=d1/(d1+d2);
		}
		// Рисуем кривую по частям
		for (i=0;i<n;i++) { // Рисуем первую часть кривой
			if (P[i]<tail_pos-h) ctx.lineTo(X[i],Y[i]); // Часть дуги
			else { // Хвостик
				ctx.lineTo(x_tail,y_tail); // Линия к точке
				j=i;
				break;
			}
		}
		for (i=j;i<n;i++) { // Оставшаяся часть
			if (P[i]>tail_pos+h) ctx.lineTo(X[i],Y[i]); // Часть дуги
		}
	}

}	
//=================================================================================
// Описываем глобальную переменную
var SPE;
// Ждём завершения загрузки
document.addEventListener("DOMContentLoaded", function(event) { SPE=new SPE4; });
//=================================================================================
